
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include <assert.h>
#include <string.h>

#include "initng.h"
#include "initng_active_state.h"
#include "initng_global.h"


int initng_add_state(a_state_h * state)
{
    assert(state);

    /* look for duplets */
    if (initng_find_state(state->state_name) != NULL)
    {
        F_("There exists a state with this state_name already, please check this!\n");
        return (FALSE);
    }

    D_("adding %s.\n", state->state_name);
    list_add(&(state->list), &(g.states.list));
    return (TRUE);
}

a_state_h *initng_find_state(const char *state_name)
{
    a_state_h *current = NULL;

    assert(state_name);

    /* walk the state db */
    while_states(current)
    {
        if (strcmp(state_name, current->state_name) == 0)
            return (current);
    }
    return (NULL);
}
