#include <sys/types.h>
#include <sys/reboot.h>
#include <signal.h>
#include <string.h>
#include <fcntl.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <unistd.h>

int main(int argc, char *const argv[])
{

    sync();

    if (getuid() != 0)
    {
        printf("Have to be root with pid = 0!\n");
        return (1);
    }

    sync();

    if (argc != 2)
    {
        printf("Wrong number of arguments!\n");
        printf("usage:\n");
        printf(" %s reboot\n", argv[0]);
        printf(" %s halt\n", argv[0]);
        printf(" %s poweroff\n\n", argv[0]);
        return (1);
    }

    sync();

    /* and finally reboot, halt or power-off the system */
    if (strcasecmp(argv[1], "reboot") == 0)
    {
        reboot(RB_AUTOBOOT);
        return (0);
    }
    else if (strcasecmp(argv[1], "halt") == 0)
    {
        reboot(RB_HALT_SYSTEM);
        return (0);
    }
    else if (strcasecmp(argv[1], "poweroff") == 0)
    {
        reboot(RB_POWER_OFF);
        return (0);
    }
    return (1);
}
